/*
	File : core_portme.c
*/
/*
	Author : Shay Gal-On, EEMBC
	Legal : TODO!
*/

#include "coremark.h"
#include "core_portme.h"
#include "simple_time.h"


// Configuration Bit settings
// SYSCLK = 80 MHz (8MHz Crystal/ FPLLIDIV * FPLLMUL / FPLLODIV)
// PBCLK = SYSCLK/1
// Primary Osc w/PLL (XT+,HS+,EC+PLL)
// WDT OFF
// Other options are don't care
//
//#if	FOSC == 80000000UL
//#pragma config FPLLIDIV = DIV_2, FPLLMUL = MUL_20, FPLLODIV = DIV_1
//#elif	FOSC == 30000000UL
//#pragma config FPLLIDIV = DIV_2, FPLLMUL = MUL_15, FPLLODIV = DIV_2
//#else
//#error	Config PLL
//#endif
//#pragma config POSCMOD = HS, FNOSC = PRIPLL, FPBDIV = DIV_1, FWDTEN = OFF


#if VALIDATION_RUN
	volatile ee_s32 seed1_volatile=0x3415;
	volatile ee_s32 seed2_volatile=0x3415;
	volatile ee_s32 seed3_volatile=0x66;
#endif
#if PERFORMANCE_RUN
	volatile ee_s32 seed1_volatile=0x0;
	volatile ee_s32 seed2_volatile=0x0;
	volatile ee_s32 seed3_volatile=0x66;
#endif
#if PROFILE_RUN
	volatile ee_s32 seed1_volatile=0x8;
	volatile ee_s32 seed2_volatile=0x8;
	volatile ee_s32 seed3_volatile=0x8;
#endif
	volatile ee_s32 seed4_volatile=ITERATIONS; // ITERATION must be set by define in compilation
	volatile ee_s32 seed5_volatile=0;
/* Porting : Timing functions
	How to capture time and convert to seconds must be ported to whatever is supported by the platform.
	e.g. Read value from on board RTC, read value from cpu clock cycles performance counter etc.
	Sample implementation for standard time.h and windows.h definitions included.
*/
/* Define : TIMER_RES_DIVIDER
	Divider to trade off timer resolution and total time that can be measured.

	Use lower values to increase resolution, but make sure that overflow does not occur.
	If there are issues with the return value overflowing, increase this value.
	*/

	/* Configuration: CORE_TICKS
		Define type of return from the timing functions.
	 */
	/* Configuration : CORE_TICKS
		Define type of return from the timing functions.
	 */

/* Define Host specific (POSIX), or target specific global time variables. */
//static CORETIMETYPE start_time_val, stop_time_val;

/* Function : start_time
	This function will be called right before starting the timed portion of the benchmark.

	Implementation may be capturing a system timer (as implemented in the example code)
	or zeroing some system parameters - e.g. setting the cpu clocks cycles to 0.
*/

unsigned long startmsec, finimsec;

void start_time(void) {starttime();}

/* Function : stop_time
	This function will be called right after ending the timed portion of the benchmark.

	Implementation may be capturing a system timer (as implemented in the example code)
	or other system parameters - e.g. reading the current value of cpu cycles counter.
*/
void stop_time(void) {stoptime();}
/* Function : get_time
	Return an abstract "ticks" number that signifies time on the system.

	Actual value returned may be cpu cycles, milliseconds or any other value,
	as long as it can be converted to seconds by <time_in_secs>.
	This methodology is taken to accomodate any hardware or simulated platform.
	The sample implementation returns millisecs by default,
	and the resolution is controlled by <TIMER_RES_DIVIDER>
*/
CORE_TICKS get_time(void) {return gettime();}
/* Function : time_in_secs
	Convert the value returned by get_time to seconds.

	The <secs_ret> type is used to accomodate systems with no support for floating point.
	Default implementation implemented by the EE_TICKS_PER_SEC macro above.
*/
secs_ret time_in_secs(CORE_TICKS ticks)
{
     unsigned long clock = gettime();
     float sec = ((float)clock) / (get_cpu_clock());
     return sec;
}

ee_u32 default_num_contexts=1;

/* Function : portable_init
	Target specific initialization code
	Test for some common mistakes.
*/
void portable_init(core_portable *p, int *argc, char *argv[])
{
	// Configure the device for maximum performance.
	// Given the system clock FOSC, this function will change the flash wait states,
	// RAM wait state, enable prefetch cache and setup peripheral bus clock...
	//SYSTEMConfigPerformance(FOSC);
	//DBINIT();	// init debug stream

	//if (sizeof(ee_ptr_int) != sizeof(ee_u8 *)) {
	//	debug_printf("ERROR! Please define ee_ptr_int to a type that holds a pointer!\n");
	//}
	//if (sizeof(ee_u32) != 4) {
	//	debug_printf("ERROR! Please define ee_u32 to a 32b unsigned type!\n");
	//}
	//debug_printf("FOSC=%d\n",FOSC);
	p->portable_id=1;
}
/* Function : portable_fini
	Target specific final code
*/
void portable_fini(core_portable *p)
{
//	char x;
//	DBGETC(&x);	// flush debug stream
//	debug_gets(&x);

	p->portable_id=0;
}
