#include "runtime\system.h"

float sec = 1.0f;
int itr = 1;

typedef int (*ptr_benchmark)();
typedef struct benchmark_unit_
{
        char * name;
        ptr_benchmark f;
}benchmark_unit_t;


extern int benchmark_linpack();
extern int benchmark_coremark();
extern int benchmark_dhrystone();
extern int benchmark_whetstone();



benchmark_unit_t benchmarks[] = {{"linpack",benchmark_linpack},
                                {"coremark",benchmark_coremark},
                                {"dhrystone",benchmark_dhrystone},
                                {"whetstone",benchmark_whetstone},
                                {"end_of_task",0}};
int cache_config()
{
        mips_write_c0_register (C0_CONFIG, 3);
        MC_CSR |= MC_CSR_FLUSH_I | MC_CSR_FLUSH_D;
        int v = MC_CSR;
	asm volatile (
		"la	$26, 1f \n"
		"jr	$26 \n"
	"1:");
        return v;
}

void uart_echo_test()
{
    debug_puts("uart echo test!\n");

    int count = 0;
    while(1)
    {
      short ch = uart_getchar();
      debug_printf("uart echo test! [%d]\n", count++);
    }
}


main()
{
        cache_config();
        //uart_config (KHZ, 115200);
        uart_config (get_cpu_clock(), 115200);

        unsigned p = 0;
        while(benchmarks[p].f)
        {
                debug_printf("\033[93mstart benchmark: %s \n\033[0m",benchmarks[p].name);
                itr = (*benchmarks[p].f)();
                p++;
        }

      debug_printf("\033[93mfinish benchmarking!\n\n\n\n\033[0m");
      while (1) ;
};

